---
# Don't forget to keep this file updated
# molecule/<scenario>/verify.yml
- name: "Verify"
  hosts: "cicd-debian-12"
  gather_facts: false
  tasks:

    - name: "Get ApacheDS services current state"
      register: "install_apacheds__service_status"
      failed_when: "not install_apacheds__service_status.status.ActiveState == 'active'"
      ansible.builtin.systemd:
        name: "apacheds--{{ inv__install_apacheds__instance.name }}"

    - name: "Check ApacheDS connectivities LDAP"
      ansible.builtin.wait_for:
        host: "localhost"
        port: "10389"
        timeout: 120

    - name: "Check ApacheDS connectivities LDAPS"
      ansible.builtin.wait_for:
        host: "localhost"
        port: "10636"
        timeout: 120

    - name: "Get default admin informations from instances LDAP"
      register: 'admin_instance_result'
      failed_when: "admin_instance_result.rc != 0"
      ansible.builtin.command: "ldapsearch -x -H ldap://localhost:10389 -D 'uid=admin,ou=system' -b 'dc=example,dc=com' -w '{{ inv__install_apacheds__instance.system_password }}'"

    - name: "Get builded objects from instances LDAP: LDAP users"
      loop: "{{ inv__install_apacheds__instance_ldap_users }}"
      loop_control:
        loop_var: "ldap_user"
      register: "admin_instance_result"
      failed_when: "admin_instance_result.rc != 0"
      ansible.builtin.command: "ldapsearch -x -H ldap://localhost:10389 -D 'uid=admin,ou=system' -b 'uid={{ ldap_user.uid }},ou=users,ou=system' -w '{{ inv__install_apacheds__instance.system_password }}'"

    - name: "Get builded objects from instances LDAP: instance domains"
      loop: "{{ inv__install_apacheds__instance_domains }}"
      loop_control:
        loop_var: "domain"
      register: "admin_instance_result"
      failed_when: "admin_instance_result.rc != 0"
      ansible.builtin.command: "ldapsearch -x -H ldap://localhost:10389 -D 'uid=admin,ou=system' -b 'dc={{ domain }},dc=example,dc=com' -w '{{ inv__install_apacheds__instance.system_password }}'"

    - name: "Get builded objects from instances LDAP: instance organizations"
      loop: "{{ inv__install_apacheds__instance_organizations }}"
      loop_control:
        loop_var: "organization"
      register: "admin_instance_result"
      failed_when: "admin_instance_result.rc != 0"
      ansible.builtin.command: "ldapsearch -x -H ldap://localhost:10389 -D 'uid=admin,ou=system' -b 'o={{ organization.o }},{{ organization.parents }}' -w '{{ inv__install_apacheds__instance.system_password }}'"

    - name: "Get builded objects from instances LDAP: instance organizational units"
      loop: "{{ inv__install_apacheds__instance_organizational_units }}"
      loop_control:
        loop_var: "organizational_unit"
      register: "admin_instance_result"
      failed_when: "admin_instance_result.rc != 0"
      ansible.builtin.command: "ldapsearch -x -H ldap://localhost:10389 -D 'uid=admin,ou=system' -b 'ou={{ organizational_unit.ou }},{{ organizational_unit.parents }}' -w '{{ inv__install_apacheds__instance.system_password }}'"

    - name: "Get builded objects from instances LDAP: instance groups of names"
      loop: "{{ inv__install_apacheds__instance_group_of_names }}"
      loop_control:
        loop_var: "group_of_name"
      register: "admin_instance_result"
      failed_when: "admin_instance_result.rc != 0"
      ansible.builtin.command: "ldapsearch -x -H ldap://localhost:10389 -D 'uid=admin,ou=system' -b 'cn={{ group_of_name.cn }},{{ group_of_name.parents }}' -w '{{ inv__install_apacheds__instance.system_password }}'"

    - name: "Get builded objects from instances LDAP: instance accounts"
      loop: "{{ inv__install_apacheds__instance_accounts }}"
      loop_control:
        loop_var: "account"
      register: "admin_instance_result"
      failed_when: "admin_instance_result.rc != 0"
      ansible.builtin.command: "ldapsearch -x -H ldap://localhost:10389 -D 'uid=admin,ou=system' -b 'uid={{ account.uid }},{{ account.parents }}' -w '{{ inv__install_apacheds__instance.system_password }}'"
